MODULE ShdMemRcv;

IMPORT Types, SO, Cfg, Log, Config;
IMPORT Mot, Tmr, ShdMem;
FROM SYSTEM IMPORT BYTE;

CONST
  mid = Cfg.midShdMemRcv;

VAR
  rdr: ShdMem.TRdr;
  t0: Tmr.TTicks;


PROCEDURE Message( s-: ARRAY OF CHAR );
BEGIN
  Log.Write( mid, Log.lvlMsg, s, FALSE );
END Message;

PROCEDURE Error( s-: ARRAY OF CHAR );
BEGIN
  Log.Write( mid, Log.lvlErr, s, TRUE );
END Error;

PROCEDURE Fatal( s-: ARRAY OF CHAR );
BEGIN
  Log.Write( mid, Log.lvlFat, s, TRUE );
  HALT;
END Fatal;


PROCEDURE WrHex( VAR b: SO.TBuffer; x-: ARRAY OF BYTE; l: CARDINAL );
CONST
  lMax = 512;
VAR
  i: CARDINAL;
  c: CHAR;
BEGIN
  IF l > SIZE( x ) THEN l := SIZE( x ) END;
  IF l > lMax THEN l := lMax END;
  IF l = 0 THEN RETURN END;
  c := b.c.p;
  b.c.p := '0';
  DEC( l );
  FOR i := 0 TO l DO
    SO.WrShtHex( b, Types.TShtCard( x[i] ), 2 );
    IF i < l THEN SO.WrChar( b, ' ' ) END;
  END;
  b.c.p := c;
END WrHex;

PROCEDURE Check( x-: ARRAY OF BYTE; l: CARDINAL );

  PROCEDURE Show( i: CARDINAL );
  CONST
    ena = TRUE;
  VAR
    b: SO.TBuffer;
    s: ARRAY [0..1024] OF CHAR;
  BEGIN
    IF ~ ena THEN RETURN END;
    SO.Init( b, s );
    SO.WrStr( b, 'Check: ' );
    SO.WrLngCard( b, i, 1 );
    SO.WrStr( b, ' ' );
    SO.WrLngCard( b, l, 1 );
    SO.WrStr( b, '  ' );
    WrHex( b, x, l );
    Error( s );
  END Show;

VAR
  b: BYTE;
  i: CARDINAL;
BEGIN
  b := x[0];
  FOR i := 1 TO l - 1 DO
    IF x[i] # b THEN Show( i ); HALT END;
  END;
END Check;

PROCEDURE Update();

  PROCEDURE Show();
  CONST
    ena = FALSE;
  VAR
    b: SO.TBuffer;
    s: ARRAY [0..127] OF CHAR;
  BEGIN
    IF ~ ena THEN RETURN END;
    SO.Init( b, s );
    SO.WrStr( b, 'Update: ' );
    SO.WrLngCard( b, Mot.cnt, 1 );
    Message( s );
  END Show;

CONST
  len = 128;
VAR
  n: CARDINAL;
  x: ARRAY [0..len-1] OF BYTE;
BEGIN
  IF Tmr.Diff( t0, Tmr.Ticks() ) >= Config.data.dur THEN HALT END;
  n := ShdMem.Read( rdr, x, len );
  Check( x, len );
  Show();
END Update;


BEGIN
  Log.Register( mid, 'ShdMemRc' );
  rdr := ShdMem.NewRdr( ShdMem.idMain );
  t0 := Tmr.Ticks();
  Mot.Exec( Update );
END ShdMemRcv.
