(* system ticks (ms) since prg start *)
(* solyga@gmx.de, 2019-12-26 *)
IMPLEMENTATION MODULE Tmr;

IMPORT (* WinBase, *) MMSys, Mtxs;

VAR
  tcs: TTicks;
  win: TTicks;
  mtx: Mtxs.TMtx;


PROCEDURE Enter();
BEGIN
  Mtxs.Req( mtx );
END Enter;

PROCEDURE Leave();
BEGIN
  Mtxs.Rel( mtx );
END Leave;


CONST Now ::= MMSys.Ticks;  (* WinBase.GetTickCount; *)


PROCEDURE Update();
VAR
  w, d: TTicks;
BEGIN
  w := Now();
  d := Diff( win, w );
  tcs := Add( tcs, d );
  win := w;
END Update;


PROCEDURE Ticks(): TTicks;
VAR
  t: TTicks;
BEGIN
  Enter();
  Update();
  t := tcs;
  Leave();
  RETURN t;
END Ticks;

PROCEDURE WinTicks(): TTicks;
VAR
  t: TTicks;
BEGIN
  Enter();
  Update();
  t := win;
  Leave();
  RETURN t;
END WinTicks;


BEGIN
  tcs := 0;
  win := Now();
  mtx := Mtxs.New();
END Tmr.
